﻿Public Sub Main(ByVal rootDeviceRef As Object)
        'Devices:
        'Root: Heating, Cooling
        'Mode: Manual, Auto, Off
        'Thermostat: Range 5 - 40, step 0.5
        'Temperature: Adjustet for location
    End Sub

    Private Enum Modes
        Off = 0
        Manual = 1
        Auto = 2
    End Enum

    Private Enum ThermostatDeviceType
        Thermostat_Mode = 1
        Thermostat_Setpoint = 2
        Thermostat_Temperature = 3
    End Enum

    Public Sub UpdateConfig(ByVal input As Object)
        Dim rootDeviceRef As Integer = CInt(input.ToString.Split("|")(0))
        Dim s As New ThermostatSettings(hs, rootDeviceRef)

        s.Load(input.ToString.Split("|")(1))

        s.Save(hs, rootDeviceRef)
    End Sub

    Public Sub Setup(ByVal inputString As Object)
        'HeaterDeviceReference=78,ExernalTemperatureSensorRef=394

        Try
            Dim SVpair As HomeSeerAPI.VSPair
            Dim VGpair As HomeSeerAPI.VGPair

            '=============
            'Root device
            'Mode device
            '=============
            Dim rootRef As Integer = hs.NewDeviceRef("Mode")
            Dim rootDevice As Scheduler.Classes.DeviceClass = hs.GetDeviceByRef(rootRef)
            rootDevice.Location(hs) = "VirtualThermostat"
            rootDevice.Location2(hs) = "VirtualThermostat"
            rootDevice.Device_Type_String(hs) = ThermostatDeviceType.Thermostat_Mode.ToString
            rootDevice.DeviceType_Set(hs) = New HomeSeerAPI.DeviceTypeInfo
            rootDevice.Status_Support(hs) = True
            rootDevice.Can_Dim(hs) = False
            hs.SaveEventsDevices()
            rootDevice.MISC_Set(hs, HomeSeerAPI.Enums.dvMISC.SHOW_VALUES)
            rootDevice.MISC_Clear(hs, HomeSeerAPI.Enums.dvMISC.STATUS_ONLY)

            For i As Integer = 0 To 3
                Dim value As Modes = i

                SVpair = New HomeSeerAPI.VSPair(HomeSeerAPI.ePairStatusControl.Status)
                SVpair.PairType = HomeSeerAPI.VSVGPairType.SingleValue
                SVpair.Value = CInt(value)
                SVpair.Status = value.ToString
                hs.DeviceVSP_AddPair(rootRef, SVpair)

                VGpair = New HomeSeerAPI.VGPair
                VGpair.PairType = HomeSeerAPI.VSVGPairType.SingleValue
                VGpair.Set_Value = CInt(value)
                Select Case CInt(value)
                    Case Is = Modes.Off
                        VGpair.Graphic = "images/HomeSeer/contemporary/off.gif"
                    Case Is = Modes.Manual
                        VGpair.Graphic = "images/HomeSeer/contemporary/yellow.png"
                    Case Is = Modes.Auto
                        VGpair.Graphic = "images/HomeSeer/contemporary/green.png"
                End Select
                hs.DeviceVGP_AddPair(rootRef, VGpair)

                hs.DeviceScriptButton_AddButton(rootRef, value.ToString, CInt(value), scriptName, "ModeButtonPress", CInt(value), 1, CInt(value) + 1, 1)
            Next

            Dim s As New ThermostatSettings(inputString.ToString)
            s.Save(hs, rootRef)


            '=============
            'Thermostat device
            '=============
            Dim thermostatRef As Integer = hs.NewDeviceRef("Setpoint")
            Dim thermostatDevice As Scheduler.Classes.DeviceClass = hs.GetDeviceByRef(thermostatRef)
            thermostatDevice.Location(hs) = "VirtualThermostat"
            thermostatDevice.Location2(hs) = "VirtualThermostat"
            thermostatDevice.Device_Type_String(hs) = ThermostatDeviceType.Thermostat_Setpoint.ToString
            thermostatDevice.DeviceType_Set(hs) = New HomeSeerAPI.DeviceTypeInfo
            thermostatDevice.Status_Support(hs) = True
            thermostatDevice.Can_Dim(hs) = False
            hs.SaveEventsDevices()
            thermostatDevice.MISC_Set(hs, HomeSeerAPI.Enums.dvMISC.SHOW_VALUES)
            thermostatDevice.MISC_Clear(hs, HomeSeerAPI.Enums.dvMISC.STATUS_ONLY)

            Dim tempStart As Double = 5
            Dim tempEnd As Double = 35
            For i As Double = tempStart To tempEnd Step 0.5
                SVpair = New HomeSeerAPI.VSPair(HomeSeerAPI.ePairStatusControl.Both)
                SVpair.PairType = HomeSeerAPI.VSVGPairType.SingleValue
                SVpair.Value = i
                SVpair.Status = i & " °C"
                SVpair.Render = HomeSeerAPI.Enums.CAPIControlType.Values
                SVpair.Render_Location.Row = 1
                SVpair.Render_Location.Column = 1
                SVpair.Render_Location.ColumnSpan = 1
                hs.DeviceVSP_AddPair(thermostatRef, SVpair)
            Next
            hs.SetDeviceValueByRef(thermostatRef, 17.5, False)
            hs.DeviceScriptButton_AddButton(thermostatRef, "-", 200, scriptName, "SetpointButtonPress", ScriptParm:=200, Row:=1, Column:=2, ColumnSpan:=1)
            hs.DeviceScriptButton_AddButton(thermostatRef, "+", 201, scriptName, "SetpointButtonPress", ScriptParm:=201, Row:=1, Column:=3, ColumnSpan:=1)

            VGpair = New HomeSeerAPI.VGPair
            VGpair.PairType = HomeSeerAPI.VSVGPairType.Range
            VGpair.RangeStart = 0
            VGpair.RangeEnd = 1000
            VGpair.Graphic = "images/HomeSeer/contemporary/Thermometer-50.png"
            hs.DeviceVGP_AddPair(thermostatRef, VGpair)


            '=============
            'Temperature device
            '=============
            Dim roomTempRef As Integer = hs.NewDeviceRef("Room temperature")
            Dim roomTempDevice As Scheduler.Classes.DeviceClass = hs.GetDeviceByRef(roomTempRef)

            roomTempDevice.Location(hs) = "VirtualThermostat"
            roomTempDevice.Location2(hs) = "VirtualThermostat"
            roomTempDevice.Device_Type_String(hs) = ThermostatDeviceType.Thermostat_Temperature.ToString
            roomTempDevice.DeviceType_Set(hs) = New HomeSeerAPI.DeviceTypeInfo
            roomTempDevice.Status_Support(hs) = True
            roomTempDevice.Can_Dim(hs) = False
            hs.SaveEventsDevices()
            roomTempDevice.MISC_Set(hs, HomeSeerAPI.Enums.dvMISC.SHOW_VALUES)
            roomTempDevice.MISC_Set(hs, HomeSeerAPI.Enums.dvMISC.STATUS_ONLY)

            SVpair = New HomeSeerAPI.VSPair(HomeSeerAPI.ePairStatusControl.Status)
            SVpair.PairType = HomeSeerAPI.VSVGPairType.Range
            SVpair.RangeStart = -1000
            SVpair.RangeEnd = 1000
            SVpair.RangeStatusSuffix = " °C"
            SVpair.RangeStatusDecimals = 1
            hs.DeviceVSP_AddPair(roomTempRef, SVpair)

            VGpair = New HomeSeerAPI.VGPair
            VGpair.PairType = HomeSeerAPI.VSVGPairType.Range
            VGpair.RangeStart = -1000
            VGpair.RangeEnd = 1000
            VGpair.Graphic = "images/HomeSeer/contemporary/Thermometer-90.png"
            hs.DeviceVGP_AddPair(roomTempRef, VGpair)


            'Save devices
            hs.SaveEventsDevices()


            'Associating devices
            rootDevice.Relationship(hs) = HomeSeerAPI.Enums.eRelationship.Parent_Root
            rootDevice.AssociatedDevice_Add(hs, thermostatRef)
            rootDevice.AssociatedDevice_Add(hs, roomTempRef)
            thermostatDevice.Relationship(hs) = HomeSeerAPI.Enums.eRelationship.Child
            thermostatDevice.AssociatedDevice_Add(hs, rootRef)
            roomTempDevice.Relationship(hs) = HomeSeerAPI.Enums.eRelationship.Child
            roomTempDevice.AssociatedDevice_Add(hs, rootRef)

            'Setting up events
            Dim eventRef As Integer = hs.NewEventGetRef("Thermostat " & rootRef, "Virtual Thermostat", "")
            hs.EventSetRecurringTrigger(eventRef, New TimeSpan(0, 1, 0), False, True)
            hs.AddActionRunScript(eventRef, "VirtualThermostat.vb", "CheckTemperature", rootRef)

            hs.WriteLog("Virtual Thermostat", "New thermostat with devices created")
        Catch ex As Exception
            hs.WriteLog("Virtual Thermostat", "Error creating root device: " & ex.Message)
        End Try


    End Sub

    Public Sub ModeButtonPress(ByVal input As Object)
        Dim rootDeviceRef As Integer = input(0)
        Dim value As Modes = input(1)

        Dim s As New ThermostatSettings(hs, rootDeviceRef)

        'Updating the mode device
        hs.SetDeviceValueByRef(rootDeviceRef, CInt(value), True)

        'Updating the temperature device
        Select Case value
            Case = Modes.Off
                TurnOff(rootDeviceRef)
        End Select

        If value > Modes.Off Then CheckTemperature(rootDeviceRef)
    End Sub

    Public Sub SetpointButtonPress(ByVal input As Object)
        Dim setpointDeviceRef As Integer = input(0)
        Dim value As Integer = input(1)

        'Get the current setpoint value
        Dim devValue As Double = hs.DeviceValueEx(setpointDeviceRef)

        'Set the new setpoint value
        Select Case value
            Case = 200 'Down
                hs.SetDeviceValueByRef(setpointDeviceRef, devValue - 0.5, True)
            Case 201 'Up
                hs.SetDeviceValueByRef(setpointDeviceRef, devValue + 0.5, True)
        End Select

        'Find the root device (the setpoint device is only associated to the root device)
        Dim setpointDevice As Scheduler.Classes.DeviceClass = hs.GetDeviceByRef(setpointDeviceRef)
        Dim rootDeviceRef As Integer = 0
        If setpointDevice.AssociatedDevices_Count(hs) = 1 Then
            rootDeviceRef = setpointDevice.AssociatedDevices(hs)(0)
        End If

        If Not rootDeviceRef = 0 Then
            'Set the mode to "manual"
            If hs.DeviceValue(rootDeviceRef) <> Modes.Manual Then hs.SetDeviceValueByRef(rootDeviceRef, Modes.Manual, True)

            'Check the temperature and adjust the heater as needed
            CheckTemperature(rootDeviceRef)
        Else
            hs.WriteLog("VirtualThermostat", "Could not find root device for setpoint device")
        End If

    End Sub


    Private Function GetChildReference(ByVal rootDeviceRef As Integer, ByVal deviceType As ThermostatDeviceType) As Integer
        Dim root As Scheduler.Classes.DeviceClass = hs.GetDeviceByRef(rootDeviceRef)

        For Each i As Integer In root.AssociatedDevices(hs)
            Dim child As Scheduler.Classes.DeviceClass = hs.GetDeviceByRef(i)
            If child.Device_Type_String(hs).ToString = deviceType.ToString Then
                Return i
            End If
        Next
        Return 0
    End Function

    Private Sub UpdateTemperatureDevice(ByVal rootDeviceRef As Integer)
        Dim s As New ThermostatSettings(hs, rootDeviceRef)
        Dim roomTemperature As Double = Math.Round((hs.DeviceValueEx(s.ExternalTemperatureSensorRef) + s.TemperatureCorrectionAddition) * s.TemperatureCorrectionMultiplier, 1)

        hs.SetDeviceValueByRef(GetChildReference(rootDeviceRef, ThermostatDeviceType.Thermostat_Temperature), roomTemperature, True)
    End Sub

    Public Sub CheckTemperature(ByVal rootDeviceRef As Object)
        Dim s As New ThermostatSettings(hs, CInt(rootDeviceRef))
        UpdateTemperatureDevice(rootDeviceRef)

        Dim roomTemperature As Double = hs.DeviceValueEx(GetChildReference(rootDeviceRef, ThermostatDeviceType.Thermostat_Temperature))
        Dim setPoint As Double = hs.DeviceValueEx(GetChildReference(rootDeviceRef, ThermostatDeviceType.Thermostat_Setpoint))
        Dim lowSetPoint As Double = setPoint - s.TemperatureOffset

        If hs.DeviceValue(rootDeviceRef) = 0 Then Exit Sub

        If roomTemperature <= lowSetPoint Then
            TurnOn(rootDeviceRef)

            If s.Log Then hs.WriteLog("VirtualThermostat", "Heating ON  - Temp: " & roomTemperature & "°C - , Setpoint: " & setPoint & "°C")

        ElseIf roomTemperature > lowSetPoint AndAlso roomTemperature <= setPoint Then
            Idle()
            If s.Log Then hs.WriteLog("VirtualThermostat", "Heating IDLE - Temp: " & roomTemperature & "°C - , Setpoint: " & setPoint & "°C")


        ElseIf roomTemperature > setPoint Then
            TurnOff(rootDeviceRef)
            If s.Log Then hs.WriteLog("VirtualThermostat", "Heating OFF - Temp: " & roomTemperature & "°C - , Setpoint: " & setPoint & "°C")

        Else
            If s.Log Then hs.WriteLog("VirtualThermostat", "Heating status unchanged - Temp: " & roomTemperature & "°C - Setpoint: " & setPoint & "°C")
        End If

    End Sub

    Private Sub TurnOff(ByVal rootDeviceRef As Object)
        Dim s As New ThermostatSettings(hs, rootDeviceRef)
        Dim cc As HomeSeerAPI.CAPI.CAPIControl = hs.CAPIGetSingleControl(s.HeaterDeviceReference, True, s.HeaterCommandOff.ToLower, False, False)
        Dim ccResponse As HomeSeerAPI.CAPI.CAPIControlResponse = hs.CAPIControlHandler(cc)
        If s.Log Then hs.WriteLog("Virtual Thermostat", "Turn Off: " & ccResponse.ToString & " for device " & s.HeaterDeviceReference)
    End Sub

    Private Sub TurnOn(ByVal rootDeviceRef As Integer)
        Dim s As New ThermostatSettings(hs, rootDeviceRef)

        Dim cc As HomeSeerAPI.CAPI.CAPIControl = hs.CAPIGetSingleControl(s.HeaterDeviceReference, True, s.HeaterCommandOn.ToLower, False, False)
        Dim ccResponse As HomeSeerAPI.CAPI.CAPIControlResponse = hs.CAPIControlHandler(cc)
        If s.Log Then hs.WriteLog("Virtual Thermostat", "Turn Off: " & ccResponse.ToString & " for device " & s.HeaterDeviceReference)
    End Sub

    Private Sub Idle()
        'Do nothing
    End Sub



    Class ThermostatSettings
        Public Property ExternalTemperatureSensorRef As Integer = 0

        Public Property TemperatureCorrectionMultiplier As Integer = 1
        Public Property TemperatureCorrectionAddition As Integer = 0
        Public Property TemperatureOffset As Double = 0.3

        Public Property HeaterDeviceReference As Integer = 0
        Public Property HeaterCommandOn As String = "On"
        Public Property HeaterCommandOff As String = "Off"

        Public Property TemperatureHigh As Double = 22
        Public Property TemperatureLow As Double = 18

        Public Property Log As Boolean = False

        Public Sub Save(ByRef hs As Object, ByVal rootDeviceRef As Integer)
            Dim sb As New System.Text.StringBuilder
            sb.Append("ExternalTemperatureSensorRef=" & Me.ExternalTemperatureSensorRef & ",")

            sb.Append("TemperatureCorrectionAddition=" & Me.TemperatureCorrectionAddition & ",")
            sb.Append("TemperatureCorrectionMultiplier=" & Me.TemperatureCorrectionMultiplier & ",")
            sb.Append("TemperatureOffset=" & Me.TemperatureOffset & ",")

            sb.Append("Log=" & Me.Log & ",")

            sb.Append("HeaterDeviceReference=" & Me.HeaterDeviceReference & ",")
            sb.Append("HeaterCommandOn=" & Me.HeaterCommandOn & ",")
            sb.Append("HeaterCommandOff=" & Me.HeaterCommandOff & ",")

            sb.Append("TemperatureHigh=" & Me.TemperatureHigh & ",")
            sb.Append("TemperatureLow=" & Me.TemperatureLow & ",")

            Dim rootDevice As Scheduler.Classes.DeviceClass = hs.GetDeviceByRef(rootDeviceRef)
            Dim dt As HomeSeerAPI.DeviceTypeInfo = rootDevice.DeviceType_Get(Nothing)
            dt.Device_SubType_Description = sb.ToString

            rootDevice.DeviceType_Set(Nothing) = dt

            hs.SaveEventsDevices()
        End Sub

        Public Sub New(ByRef hs As Object, ByVal rootDeviceRef As Integer)
            Dim rootDevice As Scheduler.Classes.DeviceClass = hs.GetDeviceByRef(rootDeviceRef)
            Dim inputString As String = rootDevice.DeviceType_Get(hs).Device_SubType_Description.ToString

            Load(inputString)
        End Sub

        Public Sub New(ByVal inputString As String)
            Load(inputString)
        End Sub

        Public Sub Load(ByVal inputString As String)
            Dim lines() As String = inputString.Split(",")

            For Each line As String In lines
                Dim properties() As String = line.Split("=")
                Select Case properties(0)
                    Case = "ExternalTemperatureSensorRef"
                        Me.ExternalTemperatureSensorRef = CInt(properties(1))
                    Case = "TemperatureCorrectionAddition"
                        Me.TemperatureCorrectionAddition = CInt(properties(1))
                    Case = "TemperatureCorrectionMultiplier"
                        Me.TemperatureCorrectionMultiplier = CInt(properties(1))
                    Case = "TemperatureOffset"
                        Me.TemperatureOffset = CInt(properties(1))
                    Case = "Log"
                        Me.Log = CBool(properties(1))
                    Case = "HeaterDeviceReference"
                        Me.HeaterDeviceReference = CInt(properties(1))
                    Case = "HeaterCommandOn"
                        Me.HeaterCommandOn = properties(1)
                    Case = "HeaterCommandOff"
                        Me.HeaterCommandOff = properties(1)
                    Case = "TemperatureHigh"
                        Me.TemperatureHigh = properties(1)
                    Case = "TemperatureLow"
                        Me.TemperatureLow = properties(1)
                End Select
            Next

            'HeaterDeviceReference=78,ExernalTemperatureSensorRef=394
        End Sub
    End Class